<?php
/**===========================================================================================
# mod_megamaps		Mega Maps Module For Joomla 1.6.0
#=============================================================================================
# author				OmegaTheme.com
# copyright				Copyright (C) 2011 OmegaTheme.com. All rights reserved.
# @license - http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL
# Website				http://omegatheme.com
# Technical support		Forum - http://omegatheme.com/forum/
#=============================================================================================*/


/**------------------------------------------------------------------------
* file: helper.php 1.6.0 00001, Mar 2011 12:00:00Z OmegaTheme:Linh $
* package:	Mega Maps module
* description: module helper file	
*------------------------------------------------------------------------*/
 
// no direct access
defined('_JEXEC') or die('Restricteted access');

abstract class modMegaMapsHelper
{
	public static function getMaps(&$params)
	{
		$address = $params->get('address');
		$add_arr = explode(';', trim($address));
		
		if ($add_arr && !empty($add_arr))
		{
			$add_arr1 = array();
			foreach ($add_arr as $add)
			{
				$add_arr1[] = explode(':', trim(str_replace(array('{','}'), array('',''), $add)));
				
			}
			foreach ($add_arr1 as $index => $value)
			{
				$add_arrx = explode(',', trim($value[2]));
				foreach ($add_arrx as $idx => $valuex)
				{
					$add_arrx[$idx] = str_replace(' ', '+', trim($valuex));
				}
				$add_arr1[$index][1] = trim($add_arr1[$index][1]);
				$add_arr1[$index][2] = implode(',', $add_arrx);
			}
			
			unset($add_arr);
			unset($add_arrx);
		}
		$doc = &Jfactory::getDocument();
		$doc->addStyleSheet(JURI::root(true).'/modules/mod_megamaps/css/mod_megamaps.css');
		$map_html = '';
		$description = '';
		
		if ($params->get('map_type', 'dynamic') == 'static')
		{
			$query_url = 'http://maps.google.com/maps/api/staticmap?maptype=roadmap&size='.$params->get('map_width', 250).'x'.$params->get('map_height', 210).'&zoom='.$params->get('map_default_zoom_level', 12).'&sensor=false&center='.$add_arr1[0][2];
			$marker_size = $params->get('address_markers_size','') != '' ? 'size:'.$params->get('address_markers_size','').'%7C' : '';
			
			foreach ($add_arr1 as $index => $add)
			{
				$query_url .= '&markers='.$marker_size.'color:'.trim($params->get('address_markers_color', 'blue')).'%7Clabel:'.strtoupper($add[0]).'%7C'.$add[2];
				$description .= '<div class="list_item_wrap_static"><span> '.$add[0].': '.$add[1].'<br /><small> '.str_replace('+',' ',$add[2]).'</small></span></div>';
			}
			$map_html .= '<img alt="loading maps..." src="'.$query_url.'" />
						<div id="location_list_static">'.$description.'</div>';
		}
		else
		{
			
			$custom_style = "
				#map_canvas".$params->get('map_id_sfx')." {
					width: {$params->get('map_width', 250)}px;
					height: {$params->get('map_height', 210)}px;
					position: relative;
				}
			";
			$doc->addStyleDeclaration($custom_style);
			?>
			<script type="text/javascript" charset="utf-8">
			//<![CDATA[
			var points = [];
			<?php
			$i = 0;
			foreach ($add_arr1 as $index => $value )
			{
				echo 'points['.$index.'] = {
					label: "'.$value[0].'",
					name: "'.$value[1].'",
					address: "'.$value[2].'",
					original_add: "'.str_replace('+', ' ', $value[2]).'"
				};';
				
				$i++;
			}
			?>
			//]]>
			</script>
			<?php
			$map_html .= '<div id="map_canvas'.$params->get('map_id_sfx').'"><img src="http://maps.google.com/maps/api/staticmap?center=21.614306, 105.856919&zoom=12&size='.$params->get('map_width', 250).'x'.$params->get('map_height', 210).'&maptype=roadmap&sensor=false"/><span class="loading">'.JTEXT::_('MAP_LOADING').'</span></div>
						<div id="location_list"><div class="location_list_tip">'.JTEXT::_('CLICK_ITEM_BELOW_TO_MOVE_TO').'</div></div>';
			$map_html .= '<script type="text/javascript">
							var map;
							var geoCoder;
							var markers = [];
							var counter = 0;
							
							var ErrMsg = {
								ERROR: "'.JTEXT::_('GEOCODE_ERROR').'",
								INVALID_REQUEST: "'.JTEXT::_('GEOCODE_INVALID_REQUEST').'",
								OVER_QUERY_LIMIT: "'.JTEXT::_('GEOCODE_OVER_QUERY_LIMIT').'",
								REQUEST_DENIED: "'.JTEXT::_('GEOCODE_REQUEST_DENIED').'",
								UNKNOWN_ERROR: "'.JTEXT::_('GEOCODE_UNKNOWN_ERROR').'",
								ZERO_RESULTS: "'.JTEXT::_('GEOCODE_ZERO_RESULTS').'"
							};
							
							function initMap() {
								map = new google.maps.Map(document.getElementById("map_canvas'.$params->get('map_id_sfx').'"), {
										zoom: '.$params->get("map_default_zoom_level", 12).',
										center: new google.maps.LatLng(21.614306, 105.856919),
										mapTypeId: google.maps.MapTypeId.ROADMAP,
										mapTypeControlOptions: {style: google.maps.MapTypeControlStyle.DROPDOWN_MENU}
								});
								
								geoCoder = new google.maps.Geocoder();
								getLaLo();								
							}
							
							function getLaLo(){
								if (counter == points.length)
								{
									if(markers.length > 0) map.panTo(markers[0].position);
									return;
								}
								
								var geoRequest ={
									address: points[counter].address
								};
								
								geoCoder.geocode(geoRequest, function (result, status)
								{
									if (status == google.maps.GeocoderStatus.OK){
										var list_item = document.createElement("a");
										list_item.style.textDecoration = "none";
										list_item.style.lineHeight = "1.5em";
										list_item.style.padding = "1px 5px";
										list_item.style.display = "block";
										list_item.setAttribute("class","location_list_item");
										list_item.setAttribute("href","javascript:gotoThisLoc("+result[0].geometry.location.lat()+","+result[0].geometry.location.lng()+")");
										list_item.setAttribute("title", result[0].formatted_address);
										list_item.setAttribute("label", points[counter].label);
										list_item.setAttribute("address", points[counter].address);
										list_item.setAttribute("lat", result[0].geometry.location.lat());
										list_item.setAttribute("lng", result[0].geometry.location.lng());
										list_item.innerHTML = points[counter].label+": "+points[counter].name;
										
										var list_item_wrap = document.createElement("div");
										list_item_wrap.setAttribute("class","list_item_wrap");
										list_item_wrap.style.background = "#EEEEEE";
										list_item_wrap.style.margin = "1px 0";
										list_item_wrap.appendChild(list_item);
										document.getElementById("location_list").appendChild(list_item_wrap);
										createMarker(result[0].geometry.location, points[counter].label, points[counter].name, result[0].formatted_address);	
									}
									else {
										var err_msg = document.createElement("div");
										err_msg.setAttribute("class","result_error");
										err_msg.style.color = "#CC0000";
										err_msg.style.background = "#EEEEEE";
										err_msg.style.padding = "1px 5px";
										if (status == google.maps.GeocoderStatus.INVALID_REQUEST || status == google.maps.GeocoderStatus.ZERO_RESULTS)
										{
											err_msg.innerHTML = ErrMsg[status]+": "+points[counter].original_add;
										}
										else{
											err_msg.innerHTML = ErrMsg[status];
										}
										document.getElementById("location_list").appendChild(err_msg);
										counter += 1;
										getLaLo();
									}
								});
							}

							function createMarker(latlng, label, name, address) {
								var html = "<strong>" + label + " - " + name + ": " + "</strong><br /><small>" + address +"</small>";
								var marker = new google.maps.Marker({
									map: map,
									position: latlng,
									label: label,
									title: points[counter].name+": "+address
								});
								var infowindow = new google.maps.InfoWindow({
									content: html,
									size: new google.maps.Size(30,50)
								});
								google.maps.event.addListener(marker, "click", function() {
									infowindow.open(map,marker);
								});
								markers.push(marker);
								counter = counter + 1;
								getLaLo();
							}
							
							function gotoThisLoc(lat, lng)
							{
								map.panTo(new google.maps.LatLng(lat, lng));
							}
							
							function loadScript() {
								var script = document.createElement("script");
								script.type = "text/javascript";
								script.src = "http://maps.google.com/maps/api/js?sensor=false&callback=initMap";
								document.body.appendChild(script);
							}
							
							window.onload = loadScript;
						</script>';
		}
		return $map_html;
	}
}
